<template>
  <div
    id="_app"
  >
    <component
      :is="getLayoutComponent()"
      v-bind="getLayoutProps()"
    >
      <template #default>
        <!-- Router view -->
        <transition
          mode="out-in"
          enter-active-class="_veryfaster animated fadeIn"
          leave-active-class="_veryfaster animated fadeOut"
          @before-leave="rvBeforeLeave"
          @after-leave="rvAfterLeave"
          @leave-cancelled="rvLeaveCancelled"
          @before-enter="rvBeforeEnter"
          @after-enter="rvAfterEnter"
          @enter-cancelled="rvEnterCancelled"
        >
          <router-view ref="routerView" />
        </transition>
      </template>
    </component>
  </div>
</template>

<script>
import { toolbox } from '@hperchec/scorpion-ui'

const { mapComponent } = toolbox.template.utils

/**
 * Root app component
 */
export default {
  name: 'App',
  refs: [
    'routerView'
  ],
  components: {
    DefaultLayout: mapComponent('vue.components.layouts.default.Layout'),
    PublicLayout: mapComponent('vue.components.layouts.public.Layout'),
    PrivateLayout: mapComponent('vue.components.layouts.private.Layout')
  },
  data () {
    return {
      currentRoute: null // see mounted hook
    }
  },
  watch: {
    '$refs.routerView': function (to, from) {
      this.$app.emit('Router/ROUTER_VIEW_UPDATED', {
        ref: to
      })
    }
  },
  mounted () {
    this.currentRoute = this.$route
  },
  methods: {
    /**
     * Returns the layout specific component
     */
    getLayoutComponent () {
      if (this.$route.meta.layout === 'public') {
        return 'PublicLayout'
      } else if (this.$route.meta.layout === 'private') {
        return 'PrivateLayout'
      } else {
        return 'DefaultLayout'
      }
    },
    /**
     * Get layout component props based on Route meta
     */
    getLayoutProps () {
      return this.$route.meta.layoutProps || {}
    },
    // router-view @before-leave
    rvBeforeLeave (el) {
      const from = this.currentRoute
      const to = this.$route
      this.$app.emit('Router/ROUTING_TRANSITION_START', { from, to, element: el })
    },
    // router-view @after-leave
    rvAfterLeave (el) {
      // ...
    },
    // router-view @leave-cancelled
    rvLeaveCancelled (el) {
      // ...
    },
    // router-view @before-enter
    rvBeforeEnter (el) {
      // ...
    },
    // router-view @after-enter
    rvAfterEnter (el) {
      const from = this.currentRoute
      const to = this.$route
      this.$app.emit('Router/ROUTING_TRANSITION_END', { from, to, element: el })
      this.currentRoute = to
    },
    // router-view @enter-cancelled
    rvEnterCancelled (el) {
      const from = this.currentRoute
      const to = this.$route
      this.$app.emit('Router/ROUTING_TRANSITION_END', { from, to, element: el })
      this.currentRoute = to
    }
  }
}
</script>

<style lang="scss">
#_app {
  @apply w-full;
}
</style>
